LeetCode #357 - Count Numbers with Unique Digits - Medium

Problem

Given a non-negative integer n, count all numbers with unique digits, x, where 0 ≤ x < 10n.

Hints:

  • A direct way is to use the backtracking approach.
  • Backtracking should contains three states which are (the current number, number of steps to get that number and a bitmask which represent which number is marked as visited so far in the current number). Start with state (0,0,0) and count all valid number till we reach number of steps equals to 10n.
  • This problem can also be solved using a dynamic programming approach and some knowledge of combinatorics.
  • Let f(k) = count of numbers with unique digits with length equals k.
  • f(1) = 10, …, f(k) = 9 * 9 * 8 * … (9 - k + 2) [The first factor is 9 because a number cannot start with 0].

Example

Given n = 2, return 91. (The answer should be the total numbers in the range of 0 ≤ x < 100, excluding [11,22,33,44,55,66,77,88,99])

Algorithm

整理一下题意:给定一个非负整数n,要求在[0,10^n]内,对所有无重复数字的数进行计数。例如,给定n=2,则返回结果为91,因为在0~100的范围内,只有9个数是包含重复数字的,这些数是11,22,33,44,55,66,77,88,99。

由于涉及一个数里的每一位数字,所以可以利用位运算来做。但是位运算方法实现较麻烦,故尝试采用另一种思路。

从数学的角度出发,本题可以转化为组合排列问题。 f(1) = 10, …, f(k) = 9 * 9 * 8 * … (9 - k + 2)…
对于n,默认n<=10,从左边第一位开始取数,有9种可能(不含0),第二位9种(含0),第三位9-1种,…,第k位有(9-k+2)(2表示第一位和第二位取走的数字)。于是当n>=2时,其可能的情况有9*(9-1)(9-2)(9-k+2)…(9-n+2)种。于是可以直接计算得到结果。

代码如下。

class Solution {
public:
    int countNumbersWithUniqueDigits(int n) {
        if(n==0) return 1;
        if(n==1) return 10;

        int count=10;
        int f=9;
        for(int k=2;k<=n;k++){
            f*=(9-k+2);
            count+=f;
        }

        return count;
    }
};
  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值